diff --git a/task.c b/task.c
index 95d9130..661c104 100644
--- a/task.c
+++ b/task.c
@@ -567,13 +567,24 @@ irqstacks_init(void)
 
 	thread_info_buf = GETBUF(SIZE(irq_ctx));
 
-	if ((hard_sp = per_cpu_symbol_search("per_cpu__hardirq_ctx"))) {
+	if ((hard_sp = per_cpu_symbol_search("per_cpu__hardirq_ctx")) ||
+	    (hard_sp = per_cpu_symbol_search("per_cpu__hardirq_stack"))) {
 		if ((kt->flags & SMP) && (kt->flags & PER_CPU_OFF)) {
 			for (i = 0; i < NR_CPUS; i++) {
+				ulong ptr;
+
 				if (!kt->__per_cpu_offset[i])
 					continue;
-				tt->hardirq_ctx[i] = hard_sp->value +
-					kt->__per_cpu_offset[i];
+				ptr = hard_sp->value + kt->__per_cpu_offset[i];
+
+				if (!readmem(ptr, KVADDR, &ptr,
+					     sizeof(void *), "hardirq ctx",
+					     RETURN_ON_ERROR)) {
+					error(INFO, "cannot read hardirq_ctx[%d] at %lx\n",
+					      i, ptr);
+					continue;
+				}
+				tt->hardirq_ctx[i] = ptr;
 			}
 		} else 
 			tt->hardirq_ctx[0] = hard_sp->value;
@@ -585,29 +596,42 @@ irqstacks_init(void)
 	} else 
 		error(WARNING, "cannot determine hardirq_ctx addresses\n");
 
-	for (i = 0; i < NR_CPUS; i++) {
-        	if (!(tt->hardirq_ctx[i]))
-                        continue;
+	if (MEMBER_EXISTS("irq_ctx", "tinfo")) {
+		for (i = 0; i < NR_CPUS; i++) {
+			if (!(tt->hardirq_ctx[i]))
+				continue;
 
-                if (!readmem(tt->hardirq_ctx[i], KVADDR, thread_info_buf, 
-		    SIZE(irq_ctx), "hardirq thread_union", 
-		    RETURN_ON_ERROR)) {
-                	error(INFO, "cannot read hardirq_ctx[%d] at %lx\n",
-                            	i, tt->hardirq_ctx[i]);
-                        continue;
-                }
+			if (!readmem(tt->hardirq_ctx[i], KVADDR, thread_info_buf, 
+			    SIZE(irq_ctx), "hardirq thread_union", 
+			    RETURN_ON_ERROR)) {
+				error(INFO, "cannot read hardirq_ctx[%d] at %lx\n",
+					i, tt->hardirq_ctx[i]);
+				continue;
+			}
 
-                tt->hardirq_tasks[i] = 
-			ULONG(thread_info_buf+OFFSET(thread_info_task));
+			tt->hardirq_tasks[i] = 
+				ULONG(thread_info_buf+OFFSET(thread_info_task));
+		}
 	}
 
-	if ((soft_sp = per_cpu_symbol_search("per_cpu__softirq_ctx"))) {
+	if ((soft_sp = per_cpu_symbol_search("per_cpu__softirq_ctx")) ||
+	    (soft_sp = per_cpu_symbol_search("per_cpu__softirq_stack"))) {
 		if ((kt->flags & SMP) && (kt->flags & PER_CPU_OFF)) {
 			for (i = 0; i < NR_CPUS; i++) {
+				ulong ptr;
+
 				if (!kt->__per_cpu_offset[i])
 					continue;
-				tt->softirq_ctx[i] = soft_sp->value +
-					kt->__per_cpu_offset[i];
+				ptr = soft_sp->value + kt->__per_cpu_offset[i];
+
+				if (!readmem(ptr, KVADDR, &ptr,
+					     sizeof(void *), "softirq ctx",
+					     RETURN_ON_ERROR)) {
+					error(INFO, "cannot read softirq_ctx[%d] at %lx\n",
+					      i, ptr);
+					continue;
+				}
+				tt->softirq_ctx[i] = ptr;
 			}
 		} else 
 			 tt->softirq_ctx[0] = soft_sp->value;
@@ -619,21 +643,23 @@ irqstacks_init(void)
 	} else
 		error(WARNING, "cannot determine softirq_ctx addresses\n");
 
-        for (i = 0; i < NR_CPUS; i++) {
-                if (!(tt->softirq_ctx[i]))
-                        continue;
-
-                if (!readmem(tt->softirq_ctx[i], KVADDR, thread_info_buf,
-                    SIZE(irq_ctx), "softirq thread_union",
-                    RETURN_ON_ERROR)) {
-			error(INFO, "cannot read softirq_ctx[%d] at %lx\n",
-                       		i, tt->hardirq_ctx[i]);
-                    	continue;
-                }
-
-                tt->softirq_tasks[i] =
-                        ULONG(thread_info_buf+OFFSET(thread_info_task));
-        }
+	if (MEMBER_EXISTS("irq_ctx", "tinfo")) {
+	        for (i = 0; i < NR_CPUS; i++) {
+			if (!(tt->softirq_ctx[i]))
+				continue;
+	
+			if (!readmem(tt->softirq_ctx[i], KVADDR, thread_info_buf,
+			    SIZE(irq_ctx), "softirq thread_union",
+			    RETURN_ON_ERROR)) {
+				error(INFO, "cannot read softirq_ctx[%d] at %lx\n",
+					i, tt->hardirq_ctx[i]);
+				continue;
+			}
+	
+			tt->softirq_tasks[i] =
+				ULONG(thread_info_buf+OFFSET(thread_info_task));
+		}
+	}
 
 
         tt->flags |= IRQSTACKS;
diff --git a/x86.c b/x86.c
index 54ce7a5..27bf0ea 100644
--- a/x86.c
+++ b/x86.c
@@ -1963,6 +1963,8 @@ x86_init(int when)
 		STRUCT_SIZE_INIT(e820map, "e820map");
 		STRUCT_SIZE_INIT(e820entry, "e820entry");
 		STRUCT_SIZE_INIT(irq_ctx, "irq_ctx");
+		if (!VALID_STRUCT(irq_ctx))
+			STRUCT_SIZE_INIT(irq_ctx, "irq_stack");
 		MEMBER_OFFSET_INIT(e820map_nr_map, "e820map", "nr_map");
 		MEMBER_OFFSET_INIT(e820entry_addr, "e820entry", "addr");
 		MEMBER_OFFSET_INIT(e820entry_size, "e820entry", "size");